stages:
- build
- test
- deploy 
- trigger

variables:
  PIP_CACHE_DIR: "$CI_PROJECT_DIR/.cache/pip"
  
cache:
  paths:
  - .cache/pip
  - venv/

before_script:
- python -V  # Print out python version for debugging
- pip install virtualenv
- virtualenv venv
- source venv/bin/activate

build:
  image: python:alpine
  stage: build
  script:
  - pip3 install -r requirements.txt

test:
  image: python:alpine
  stage: test
  services:
  - name: registry.gitlab.com/webengproteam/url-shortener/database-schema:latest
    alias: db
  script:
  - source set_env.sh local
  - export DB_SERVICE=db
  - python3 -m hook_runner_server test

# Generate and push docker image for tag "latest"
deploy-docker-master-latest:
  image: docker:latest
  stage: deploy
  services:
  - docker:dind
  before_script:
  - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
  script:
  - docker build --pull -t "$CI_REGISTRY_IMAGE" .
  - docker push "$CI_REGISTRY_IMAGE"
  only:
  - master

# Generate and push docker image for tag "devel"
deploy-docker-devel:
  image: docker:latest
  stage: deploy
  services:
  - docker:dind
  before_script:
  - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
  script:
  - docker build --pull -t "$CI_REGISTRY_IMAGE:devel" .
  - docker push "$CI_REGISTRY_IMAGE:devel"
  only:
  - devel

trigger-nexus:
  image: alpine:latest
  stage: trigger
  before_script:
  - apk update && apk add curl
  script:
  - "curl -X POST -F token=$CI_TOKEN_NEXUS -F ref=master https://gitlab.com/api/v4/projects/15408515/trigger/pipeline"
  only:
  - master
